
import java.util.*;
import java.io.*;

public class CouplingDemo
{
    public CouplingDemo()
    {
          _htblCmds =   new Hashtable( );
    }

    public void loadCmds()
    {
        try
        {
            Properties  props;

            props = new Properties(  );
            props.load( new FileInputStream ( "commandstable.props" ) );
            Enumeration enumKeys = props.keys();
            while( enumKeys.hasMoreElements( ) )
            {
                 String strKey  = (String)enumKeys.nextElement( );
                 String strCmd  = (String)props.get( strKey );

                 Class  cls     = Class.forName( strCmd );
                 Object obj     = cls.newInstance( );

                 Command cmd    = (Command)obj;
                 _htblCmds.put( strKey , cmd );
            }
        }
        catch( Exception exp )
        {
            exp.printStackTrace( );  
        }
    }

    public void run( String strServiceID )
    {
            Command cmd = (Command) _htblCmds.get( strServiceID );
            cmd.execute(  );
    }

    public static void main( String strarrArgs[] )
    {
            CouplingDemo couplingDemo;

            couplingDemo    =   new CouplingDemo();
            couplingDemo.loadCmds( );

    }

    protected Hashtable     _htblCmds;
}
